osg::ValueObject Class Reference

`#include <ValueObject>`

Inheritance diagram for osg::ValueObject:

## Classes

class | GetValueVisitor
class | SetValueVisitor

## Public Member Functions

| ValueObject ()
| ValueObject (const std::string &name)
| ValueObject (const ValueObject &rhs, const osg::CopyOp copyop=osg::CopyOp::SHALLOW_COPY)
| META_Object (osg, ValueObject) virtual ValueObject *asValueObject()
virtual const ValueObject * | asValueObject () const
virtual bool | get (GetValueVisitor &) const
virtual bool | set (SetValueVisitor &)
template<typename T>
bool | getScalarValue (T &value)
template<typename T>
bool | setScalarValue (T value)
Public Member Functions inherited from osg::Object
| Object ()
| Object (bool threadSafeRefUnref)
| Object (const Object &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
virtual Object * | cloneType () const =0
virtual Object * | clone (const CopyOp &) const =0
virtual bool | isSameKindAs (const Object *) const
virtual const char * | libraryName () const =0
virtual const char * | className () const =0
std::string | getCompoundClassName () const
virtual Node * | asNode ()
virtual const Node * | asNode () const
virtual NodeVisitor * | asNodeVisitor ()
virtual const NodeVisitor * | asNodeVisitor () const
virtual StateSet * | asStateSet ()
virtual const StateSet * | asStateSet () const
virtual StateAttribute * | asStateAttribute ()
virtual const StateAttribute * | asStateAttribute () const
virtual Uniform * | asUniform ()
virtual const Uniform * | asUniform () const
virtual Camera * | asCamera ()
virtual const Camera * | asCamera () const
virtual Drawable * | asDrawable ()
virtual const Drawable * | asDrawable () const
virtual Callback * | asCallback ()
virtual const Callback * | asCallback () const
virtual CallbackObject * | asCallbackObject ()
virtual const CallbackObject * | asCallbackObject () const
virtual UserDataContainer * | asUserDataContainer ()
virtual const UserDataContainer * | asUserDataContainer () const
virtual ValueObject * | asValueObject ()
virtual Image * | asImage ()
virtual const Image * | asImage () const
virtual void | setThreadSafeRefUnref (bool threadSafe)
virtual void | setName (const std::string &name)
void | setName (const char *name)
const std::string & | getName () const
void | setDataVariance (DataVariance dv)
DataVariance | getDataVariance () const
virtual void | computeDataVariance ()
void | setUserDataContainer (osg::UserDataContainer *udc)
template<class T>
void | setUserDataContainer (const ref_ptr< T > &udc)
osg::UserDataContainer * | getUserDataContainer ()
const osg::UserDataContainer * | getUserDataContainer () const
osg::UserDataContainer * | getOrCreateUserDataContainer ()
virtual void | setUserData (Referenced *obj)
template<class T>
void | setUserData (const ref_ptr< T > &ud)
virtual Referenced * | getUserData ()
virtual const Referenced * | getUserData () const
template<typename T>
bool | getUserValue (const std::string &name, T &value) const
template<typename T>
void | setUserValue (const std::string &name, const T &value)
virtual void | resizeGLObjectBuffers (unsigned int)
virtual void | releaseGLObjects (osg::State *=0) const
template<typename T>
BoolValueObject UCharValueObject UShortValueObject UIntValueObject DoubleValueObject Vec3fValueObject Vec2dValueObject Vec4dValueObject PlaneValueObject MatrixdValueObject BoundingBoxdValueObject BoundingSpheredValueObject bool | getUserValue (const std::string &name, T &value) const
Public Member Functions inherited from osg::Referenced
| Referenced ()
| Referenced (bool threadSafeRefUnref)
| Referenced (const Referenced &)
Referenced & | operator= (const Referenced &)
bool | getThreadSafeRefUnref () const
OpenThreads::Mutex * | getRefMutex () const
int | ref () const
int | unref () const
int | unref_nodelete () const
int | referenceCount () const
ObserverSet * | getObserverSet () const
ObserverSet * | getOrCreateObserverSet () const
void | addObserver (Observer *observer) const
void | removeObserver (Observer *observer) const

## Protected Member Functions

virtual | ~ValueObject ()
Protected Member Functions inherited from osg::Object
virtual | ~Object ()
Protected Member Functions inherited from osg::Referenced
virtual | ~Referenced ()
void | signalObserversAndDelete (bool signalDelete, bool doDelete) const
void | deleteUsingDeleteHandler () const

## Additional Inherited Members

Public Types inherited from osg::Object
enum | DataVariance { DYNAMIC , STATIC , UNSPECIFIED }
Static Public Member Functions inherited from osg::Referenced
static OpenThreads::Mutex * | getGlobalReferencedMutex ()
static void | setDeleteHandler (DeleteHandler *handler)
static DeleteHandler * | getDeleteHandler ()
Protected Attributes inherited from osg::Object
std::string | _name
DataVariance | _dataVariance
osg::UserDataContainer * | _userDataContainer
Protected Attributes inherited from osg::Referenced
OpenThreads::AtomicPtr | _observerSet
OpenThreads::Atomic | _refCount

## Constructor & Destructor Documentation

## ValueObject() [1/3]

osg::ValueObject::ValueObject | ( |  | ) |

inline

References osg::Object::Object().

Referenced by asValueObject(), META_Object(), osg::TemplateValueObject< T >::TemplateValueObject(), osg::TemplateValueObject< T >::TemplateValueObject(), osg::TemplateValueObject< T >::TemplateValueObject(), osg::TemplateValueObject< T >::TemplateValueObject(), and ValueObject().

## ValueObject() [2/3]

osg::ValueObject::ValueObject | ( | const std::string & | name | ) |

inline

References osg::Object::Object(), and osg::Object::setName().

## ValueObject() [3/3]

osg::ValueObject::ValueObject | ( | const ValueObject & | rhs,
|  | const osg::CopyOp | copyop = osg::CopyOp::SHALLOW_COPY )

inline

References osg::Object::Object(), osg::CopyOp::SHALLOW_COPY, and ValueObject().

## ~ValueObject()

virtual osg::ValueObject::~ValueObject | ( |  | ) |

inline protected virtual

## Member Function Documentation

## asValueObject()

virtual const ValueObject * osg::ValueObject::asValueObject | ( |  | ) | const

inline virtual

Convert 'this' into a ValueObject pointer if Object is a ValueObject, otherwise return 0. Equivalent to dynamic_cast<ValueObject*>(this).

Reimplemented from osg::Object.

References ValueObject().

## get()

virtual bool osg::ValueObject::get | ( | GetValueVisitor & |  | ) | const

inline virtual

Reimplemented in osg::TemplateValueObject< T >.

Referenced by getScalarValue().

## getScalarValue()

template<typename T>

bool osg::ValueObject::getScalarValue | ( | T & | value | ) |

inline

References get(), osg::GetScalarValue< T >::set, and osg::GetScalarValue< T >::value.

## META_Object()

osg::ValueObject::META_Object | ( | osg | ,
|  | ValueObject | )

inline

Convert 'this' into a ValueObject pointer if Object is a ValueObject, otherwise return 0. Equivalent to dynamic_cast<ValueObject*>(this).

References ValueObject().

## set()

virtual bool osg::ValueObject::set | ( | SetValueVisitor & |  | ) |

inline virtual

Reimplemented in osg::TemplateValueObject< T >.

Referenced by setScalarValue().

## setScalarValue()

template<typename T>

bool osg::ValueObject::setScalarValue | ( | T | value | ) |

inline

References osg::SetScalarValue< T >::set, and set().

The documentation for this class was generated from the following file:

- ValueObject